function y = intmboot( data,databoots,delta,gamma,lambda,gvar)
n= gvar.n;Bsplines=gvar.Bsplines;T=gvar.T;u=gvar.u;
vgrid=gvar.vgrid;nT=length(T);T=T(:)';
delta=delta(:);
deltas=delta(1:n,:);
deltaw=delta(n+1:2*n,:);
N = length(data);n=gvar.Nsim;
r = delta(end);
V = [1,r;r,1];
u1 = normcdf(u*(V^(1/2)),0,1);
F1grid = (1-1e-4)*Bsplines*deltas+1e-4*vgrid(:);
F2grid = (1-1e-4)*Bsplines*deltaw+1e-4*vgrid(:);
vs=zeros(n,2);
vs(:,1) = interp1(F1grid,vgrid,u1(:,1));
vs(:,2) = interp1(F2grid,vgrid,u1(:,2));
[a,b]=sort(vs,2,'descend');
ID_eq = (a(:,1)==a(:,2));
strong = b(:,1)==1;
strong=strong.*(1-ID_eq)+ID_eq.*gvar.IDgen;
sdata = [a(:,2),strong];
IDdata = data(:,2)==1;
IDsdata = sdata(:,2)==1;
IDbdata = databoots(:,2)==1;
%A = sum(IDdata);
A1=sum(IDdata);A2=sum(IDsdata);A3=sum(IDbdata);
data1 = data(IDdata,1);data0 = data(~IDdata,1);
if (A1>0)&&(A1<N)
    Mdata1 = data1*T;Mdata0=data0*T;
    if A1==1
        datacos = [sum(cos(Mdata1)),sum(cos(Mdata0))]/N;
        datasin = [sum(sin(Mdata1)),sum(sin(Mdata0))]/N;
    elseif A1==N-1;
        datacos = [sum(cos(Mdata1)),cos(Mdata0)]/N;
        datasin = [sum(sin(Mdata1)),sin(Mdata0)]/N;
    else
        datacos = [sum(cos(Mdata1)),sum(cos(Mdata0))]/N;
        datasin = [sum(sin(Mdata1)),sum(sin(Mdata0))]/N;
    end
elseif A1 ==0
    Mdata0=data0*T;
    datacos = [zeros(1,nT),sum(cos(Mdata0))]/N;
    datasin = [zeros(1,nT),sum(sin(Mdata0))]/N;
elseif A1==N
    Mdata1 = data1*T;
    datacos = [sum(cos(Mdata1)),zeros(1,nT)]/N;
    datasin = [sum(sin(Mdata1)),zeros(1,nT)]/N;
end
sdata1 = sdata(IDsdata,1);sdata0 = sdata(~IDsdata,1);
if (A2>0)&&(A2<n)
    Msdata1 = sdata1*T;Msdata0=sdata0*T;
    if A2==1
        sdatacos = [cos(Msdata1),sum(cos(Msdata0))]/n;
        sdatasin = [sin(Msdata1),sum(sin(Msdata0))]/n;
    elseif A2==n-1;
        sdatacos = [sum(cos(Msdata1)),cos(Msdata0)]/n;
        sdatasin = [sum(sin(Msdata1)),sin(Msdata0)]/n;
    else
        sdatacos = [sum(cos(Msdata1)),sum(cos(Msdata0))]/n;
        sdatasin = [sum(sin(Msdata1)),sum(sin(Msdata0))]/n;
    end
elseif A2 ==0
    Msdata0=sdata0*T;
    sdatacos = [zeros(1,nT),sum(cos(Msdata0))]/n;
    sdatasin = [zeros(1,nT),sum(sin(Msdata0))]/n;
elseif A2==n
    Msdata1 = sdata1*T;
    sdatacos = [sum(cos(Msdata1)),zeros(1,nT)]/n;
    sdatasin = [sum(sin(Msdata1)),zeros(1,nT)]/n;
end

databoots1 = databoots(IDbdata,1);databoots0 = databoots(~IDbdata,1);

if (A3>0)&&(A3<N)
    Mdataboots1 = databoots1*T;Mdataboots0 = databoots0*T;
    if A3==1
        databootscos = [cos(Mdataboots1),sum(cos(Mdataboots0))]/N;
        databootssin = [sin(Mdataboots1),sum(sin(Mdataboots0))]/N;
    elseif A3==N-1
        databootscos = [sum(cos(Mdataboots1)),cos(Mdataboots0)]/N;
        databootssin = [sum(sin(Mdataboots1)),sin(Mdataboots0)]/N;
    else
        databootscos = [sum(cos(Mdataboots1)),sum(cos(Mdataboots0))]/N;
        databootssin = [sum(sin(Mdataboots1)),sum(sin(Mdataboots0))]/N;
    end
elseif A3==0
    Mdataboots0 = databoots0*T;
    databootscos = [zeros(1,nT),sum(cos(Mdataboots0))]/N;
    databootssin = [zeros(1,nT),sum(sin(Mdataboots0))]/N;
elseif A3==N
    Mdataboots1 = databoots1*T;
    databootscos = [sum(cos(Mdataboots1)),zeros(1,nT)]/N;
    databootssin = [sum(sin(Mdataboots1)),zeros(1,nT)]/N;
end

pty = (mean((datacos-sdatacos).^2)+mean((datasin-sdatasin).^2))/2;
yy = (mean((databootscos-datacos+(datacos-sdatacos)*gamma).^2)+mean((databootssin-datasin+(datasin-sdatasin)*gamma).^2))/2;
y = N*yy+lambda*pty;
end

