function y = intmoment( data,delta,gvar)
n= gvar.n;Bsplines=gvar.Bsplines;T=gvar.T;u=gvar.u;
vgrid=gvar.vgrid;nbidder=gvar.nbidder;
delta=delta(:);
deltas=delta(1:n,:);
deltaw=delta(n+1:2*n,:);
N = length(data);n=gvar.Nsim;
ce = delta(end);
V = (ones(nbidder,nbidder)-eye(nbidder))*ce+ eye(nbidder);
u1 = normcdf(u*(V^(1/2)),0,1);
F1grid = (1-1e-8)*Bsplines*deltas+1e-8*vgrid(:);
F2grid = (1-1e-8)*Bsplines*deltaw+1e-8*vgrid(:);
vs=zeros(n,nbidder);
vs(:,1) = interp1(F1grid,vgrid,u1(:,1));
vs(:,2:nbidder) = interp1(F2grid,vgrid,u1(:,2:end));
[a,b]=sort(vs,2,'descend');
sdata = [a(:,2),b(:,1)==1];
pdata = mean(data(:,2));
psdata = mean(sdata(:,2));
IDdata = data(:,2)==1;
IDsdata = sdata(:,2)==1;
data1 = data(IDdata,1);data0 = data(~IDdata,1);
sdata1 = sdata(IDsdata,1);sdata0 = sdata(~IDsdata,1);
Mdata1 = data1*T;Mdata0=data0*T;
Msdata1 = sdata1*T;Msdata0 = sdata0*T;
datacos = [sum(cos(Mdata1),1),sum(cos(Mdata0),1)]/N;
sdatacos = [sum(cos(Msdata1),1),sum(cos(Msdata0),1)]/n;
datasin = [sum(sin(Mdata1),1),sum(sin(Mdata0),1)]/N;
sdatasin = [sum(sin(Msdata1),1),sum(sin(Msdata0),1)]/n;
y = mean((datacos-sdatacos).^2)+mean((datasin-sdatasin).^2);
y = y/2*N
end

