function y = intmomentgrid( data,delta,gvar)
n= gvar.n;Int_Lpro=gvar.Int_Lpro;T=gvar.T;u=gvar.u;
vgrid=gvar.vgrid;xgridnorm=gvar.xgridnorm;Fgridnorm=gvar.Fgridnorm;
xgridcos=gvar.xgridcos;Fgridcos=gvar.Fgridcos;
xgridsin=gvar.xgridsin;Fgridsin=gvar.Fgridsin;
deltas=[1;delta(1:n-1)'];
deltaw = [1;delta(n:2*n-2)'];
N = length(data);n=gvar.Nsim;
r = delta(end);
V = [1,r,r;r,1,r;r,r,1];
u1 = interp1(xgridnorm,Fgridnorm,u*(V^(1/2)));

F1grid = Int_Lpro*kron(deltas,deltas)/sum(deltas.^2);
F2grid = Int_Lpro*kron(deltaw,deltaw)/sum(deltaw.^2);
vs=zeros(n,3);
vs(:,1) = interp1(F1grid,vgrid,u1(:,1));
vs(:,2:3) = interp1(F2grid,vgrid,u1(:,2:3));
[a,b]=sort(vs,2,'descend');
sdata = [a(:,2),b(:,1)==1];
% pdata = mean(data(:,2));
% psdata = mean(sdata(:,2));
IDdata = data(:,2)==1;
IDsdata = sdata(:,2)==1;
IDssum = sum(IDsdata);
data1 = data(IDdata,1);data0 = data(~IDdata,1);
sdata1 = sdata(IDsdata,1);sdata0 = sdata(~IDsdata,1);
Mdata1 = data1*T;Mdata0=data0*T;
Msdata1 = sdata1*T;Msdata0 = sdata0*T;
Msdata=[Msdata1;Msdata0];
Msdatacos = interp1(xgridcos,Fgridcos,Msdata);Msdatasin=interp1(xgridsin,Fgridsin,Msdata);
datacos = [sum(cos(Mdata1)),sum(cos(Mdata0))]/N;
sdatacos = [sum(Msdatacos(1:IDssum,:)),sum(Msdatacos(IDssum+1:n,:))]/n;
datasin = [sum(sin(Mdata1)),sum(sin(Mdata0))]/N;
sdatasin = [sum(Msdatasin(1:IDssum,:)),sum(Msdatasin(IDssum+1:n,:))]/n;
y = mean((datacos-sdatacos).^2)+mean((datasin-sdatasin).^2);
y = y/2*N;
end

