function y = inintial(delta,G1,G2,Xgrid1,Xgrid2,gvar)
vgrid=gvar.vgrid;Bsplines=gvar.Bsplines;
deltas=delta(1:gvar.n);
deltaw=delta(gvar.n+1:2*gvar.n);
F1 = Bsplines*deltas(:);
F2 = Bsplines*deltaw(:);

GG1 = interp1(vgrid,cumtrapz(F2,1-F1),Xgrid1);
GG2 = interp1(vgrid,cumtrapz(F1,1-F2),Xgrid2);
y = mean(abs(GG1(:)-G1(:)))+ mean(abs(GG2(:)-G2(:)));
% figure
% hold on
% plot(Xgrid1,G1,Xgrid1,GG1)
% plot(Xgrid2,G2,Xgrid2,GG2)