clear
close all
 filename='SPAdatabootnoc'
data = importdata('data.xls');
ID = data(:,1)<quantile(data(:,1),0.95);
data=data(ID,:);
a1=min(data(:,1));
a2 = max(data(:,1))-a1;
data(:,1)=data(:,1)-min(data(:,1));
data(:,1)=data(:,1)/max(data(:,1));
price=sort(data(:,1));
N = sum(ID);%sample size
P_grid = (1:N)'/N;
zgrid =linspace(0,1,1e5);
sosgrid = 2*zgrid-zgrid.^2;
Xgrid1=price;
Xgrid1=(1-1e-8)*Xgrid1+1e-8*linspace(0,1,length(Xgrid1))';

load results\SPAdatabootnoc.mat;

F_grid=interp1(sosgrid,zgrid,P_grid);

for i=1:9
    if i>1
        ID90 = logical((result{i}(:,5)<result{i}(:,6)).*(result{i}(:,2)>=CI90_low(i-1)));
        ID95 = logical((result{i}(:,5)<result{i}(:,7)).*(result{i}(:,2)>=CI95_low(i-1)));
    else
        ID90 = (result{i}(:,5)<result{i}(:,6));
        ID95 = (result{i}(:,5)<result{i}(:,7));
    end
    CI90_low(i) = min(result{i}(ID90,2));
    CI90_up(i) = max(result{i}(ID90,2));
    CI95_low(i) = min(result{i}(ID95,2));
    CI95_up(i) = max(result{i}(ID95,2));
    
end
xgrid=0:0.1:1;
CI90_low=[0,CI90_low,1];
CI90_up=[0,CI90_up,1];
CI95_low=[0,CI95_low,1];
CI95_up=[0,CI95_up,1];
ID90_up = CI90_up==0.99;
CI90_up(ID90_up)=1;
ID95_up = CI95_up==0.99;
CI95_up(ID95_up)=1;
load results\SPAdataboot.mat;
for i=1:9
    if i<9
        IDcon90 = logical((result{i}(:,5)<result{i}(:,6)));%.*(result{i}(:,2)>=CI90con_low(i-1)));
        IDcon95 = logical((result{i}(:,5)<result{i}(:,7)));%.*(result{i}(:,2)>=CI95con_low(i-1)));
    else
        IDcon90 = (result{i}(:,5)<result{i}(:,6));
        IDcon95 = (result{i}(:,5)<result{i}(:,7));
    end
    CI90con_low(i) = min(result{i}(IDcon90,2));
    CI90con_up(i) = max(result{i}(IDcon90,2));
    CI95con_low(i) = min(result{i}(IDcon95,2));
    CI95con_up(i) = max(result{i}(IDcon95,2));
    
end
for i=1:9;
    CI90con_low(i)=min(CI90con_low(i:end));
    CI95con_low(i)=min(CI95con_low(i:end));
end
xgrid=0:0.1:1;
CI90con_low=[0,CI90con_low,1];
CI90con_up=[0,CI90con_up,1];
CI95con_low=[0,CI95con_low,1];
CI95con_up=[0,CI95con_up,1];
ID90con_up = CI90con_up==0.99;
CI90con_up(ID90con_up)=1;
ID95con_up = CI95con_up==0.99;
CI95con_up(ID95con_up)=1;
xgrid= xgrid*a2+a1;
Xgrid1=Xgrid1*a2+a1;

p=figure
hold on
plot(xgrid,CI90_low,'b--x','linewidth',2)
%plot(xgrid,CI95_low,xgrid,CI95_up,'red')
plot(xgrid,CI90con_low,'k--o','linewidth',2)
%plot(xgrid,CI95con_low,xgrid,CI95con_up,'--red')
plot(Xgrid1,F_grid,'red','linewidth',2)
plot(xgrid,CI90_up,'b--x','linewidth',2)
plot(xgrid,CI90con_up,'k--o','linewidth',2)
legend('90% CI w/o FOSD','90% CI with FOSD','Symmetry and Independence','location','southeast')
figure_fullpage
%saveas(p,'SPAdata','epsc')
%plot(Xgrid1,P_grid)
%plot(Xgrid1,P_grid+1.96*(P_grid.*(1-P_grid)/N).^0.5)
%location=[pwd '\results\' filename,'.mat'];
