clear
close all
%---------------------------------------------------------------------------
%read M files
%---------------------------------------------------------------------------
name_end = 'N23_8_100_25'
for j=3:-1:1
    clear result
    filename=['SPAsimM' num2str(j), name_end]
    
    
    for i=1:550
        i
        
        name=['raw/' filename '/output',num2str(i),'.txt'];
        A = exist(name,'file');
        if A==2;
            BB = importdata(name);
            result(i,:)=BB;
        end
        
    end
    ID = result(:,1)>0;
    result= result(ID,:);
    result = result(1:500,:);
    nrep = length(result(1,2:end));
    rejM(3-j+1,:)=mean(repmat(result(:,1),1,nrep)>result(:,2:end));
        rejM1(3-j+1,:)=mean(repmat(result(:,1),1,nrep)>result(:,2:end)+1e-8);

end

%---------------------------------------------------------------------------
%read P files
%---------------------------------------------------------------------------
for j=1:6
    clear result
    filename=['SPAsimP' num2str(j), name_end]
    
    
    for i=1:1000
        i
        if j==5&&strcmp(name_end,'Nlog_8')
        name=['raw/' filename '/f1/output',num2str(i),'.txt'];
        elseif j==4&&strcmp(name_end,'N23_8')
            name=['raw/' filename '/f1/output',num2str(i),'.txt'];
        else
            name=['raw/' filename '/output',num2str(i),'.txt'];

        end
        A = exist(name,'file');
        if A==2;
            BB = importdata(name);
            if ~isempty(BB)
                result(i,:)=BB;
            end
        end
        
    end
    ID = result(:,1)>0;
      result= result(ID,:);
    result = result(1:500,:);
    nrep = length(result(1,2:end));
    rejP(j,:)=mean(repmat(result(:,1),1,nrep)>result(:,2:end));
        rejP1(j,:)=mean(repmat(result(:,1),1,nrep)>result(:,2:end)+1e-8);

end
%-------------------------------------------------------------------------
%Read 0 files
%-------------------------------------------------------------------------
filename=['SPAsim0',name_end]


for i=1:1000
    i
    
    name=['raw/' filename '/output',num2str(i),'.txt'];
    A = exist(name,'file');
    if A==2;
        BB = importdata(name);
        if ~isempty(BB)
        result(i,:)=BB;
        end
    end
    
end
ID = result(:,1)>0;  
result= result(ID,:);
result = result(1:500,:);
nrep = length(result(1,2:end));
rej0=mean(repmat(result(:,1),1,nrep)>result(:,2:end));
rej01=mean(repmat(result(:,1),1,nrep)>result(:,2:end)+1e-8);

rej_final = [rejM;rej0;rejP];
rej_final1 = [rejM1;rej01;rejP1];

fx = linspace(0.1417,0.5017,10);
rej90 = rej_final(:,1:2:end);
rej95 = rej_final(:,2:2:end);
close all
figure
hold on
plot(fx,rej95,'linewidth',2)
xlim([fx(1),fx(end)])
plot([fx(1),fx(end)],[0.05,0.05])
legend('Test 1','Test 2', 'Test 3', 'Test 4','5% line')

figure
hold on
plot(fx,rej90,'linewidth',2)
xlim([fx(1),fx(end)])
plot([fx(1),fx(end)],[0.1,0.1])

legend('Test 1','Test 2', 'Test 3', 'Test 4','10% line')

save(['final_results/rej90_longer',name_end],'rej90')
save(['final_results/rej95_longer',name_end],'rej95')

